#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Este programa lee lneas desde la entrada estndar y las imprime en la salida 
estndar. Si al momento de ejecutar el programa se especifica un archivo de entrada,
los datos se leen de este archivo en vez de la entrada estndar.
*/


int main(int argc, char * argv[]) {
    char linea[80]; //Variable para leer una lnea de entrada
    FILE *fd;      //Descriptor de archivo de entrada

    // Validacin: Si se pas un parmetro por lnea de comandos, tomar 
    // el primer parmetro  como el nombre del archivo en el cual se
    // encuentra la entrada del programa. En caso de no existir este parametro
    // o no poder abrir el archivo, usar la entrada estndar.

    if (argc > 1) { //Se especific un parmetro por lnea de comandos?
       fd = fopen(argv[1], "r");    //Intentar abrir el archivo
       if (!fd) { //No se puede abrir el archivo?
          fd = stdin; //Usar la entrada estndar (stdin = entrada estndar)
       }
    }else { //No se especific un parmetro por lnea de comandos
          fd = stdin;
    }
    
    // Leer lneas de la entrada hasta encontrar la palabra "end"

    while (!feof(fd))  { // ciclo principal
          fgets(linea, 80, fd);  //Leer una linea de hasta 80 caracteres

          //Validar si la lnea est vaca
          if (strlen(linea) <= 1) {continue;} //continue : ir al inicio del ciclo

          //Validar si la lnea es un comentario
          if (linea[0] == '#') {continue;}

          //Validar por fin de la entrada
          if (strcmp(linea, "end") == 0 || strcmp(linea, "end\n") == 0) {break;}

          //POST: la lnea es vlida, imprimirla
          printf("%s", linea); //La lnea incluye el fin de lnea '\n'
    }

    system("pause");
}


