#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Desarrollar un programa que imprima de forma ordenada una serie de nmeros.

La entrada del programa ser un conjunto de lneas, cada una de las cuales contiene
una serie de nmeros. Para cada lnea, el programa deber imprimir los nmeros en forma ordenada.

El programa deber terminar al encontrar la palabra "end"

*/

#define MAX_NUMBERS 40 // En una linea de 80 caracteres, caben maximo 40 numeros

int comparar(const void *, const void *);


int main(int argc, char * argv[]) {
    char linea[80]; //Variable para leer una lnea de entrada
    FILE *fd;      //Descriptor de archivo de entrada

    int n;      // Variable para almacenar la cantidad de numeros leidos
    int numero; //Variable para almacenar un numero leido

    int numeros[MAX_NUMBERS];

    int posicion; //Variable que almacena el desplazamiento desde el inicio de la linea
    int count; //Variable que almacena el numero de caracteres leidos

    int i;

    if (argc > 1) { //Se especific un parmetro por lnea de comandos?
       fd = fopen(argv[1], "r");    //Intentar abrir el archivo
       if (!fd) { //No se puede abrir el archivo?
          fd = stdin; //Usar la entrada estndar (stdin = entrada estndar)
       }
    }else { //No se especific un parmetro por lnea de comandos
          fd = stdin;
    }
    
    // Leer lneas de la entrada hasta encontrar la palabra "end"

    while (!feof(fd))  { //ciclo principal
          fgets(linea, 80, fd);  //Leer una linea de hasta 80 caracteres

          //Validar si la lnea est vaca
          if (strlen(linea) <= 1) {continue;} //continue : ir al inicio del ciclo

          //Validar si la lnea es un comentario
          if (linea[0] == '#') {continue;}

          //Validar por fin de la entrada
          if (strcmp(linea, "end") == 0 || strcmp(linea, "end\n") == 0) {
             break; //Terminar el ciclo
          }

          //POST: la lnea es vlida, verificar si son numeros y almacenarlos en
          // un arreglo estatico
          
         posicion = 0; //Iniciar el desplazamiento en la linea
         numero = 0;
         n = 0; //Inicializar la cantidad de numeros leidos
         while (sscanf(linea + posicion, "%d%n", &numero, &count) == 1) {                   
                  numeros[n] = numero;
                  n = n + 1;
                  posicion = posicion + count;                   
         }

         if (n > 0) { //Si se leyeron numeros, ordenarlos e imprimirlos
            //Ordenar los numeros
            qsort(numeros, n, sizeof(int), &comparar);
            for (i=0; i<n; i++) {
                printf("%d ", numeros[i]);
            }
            printf("\n");
         }
          
    }

    system("pause");
}

/*
  La funcion de comparacion que se pasa a qsort debe recibir dos parametros  de tipo void *,
  y debera retornar de la siguiente forma:
  * Un valor menor que cero, si el primer parametro es menor que el segundo.
  * Un valor igual a cero, si los dos parametros son iguales
  * Un valor mayor que cero, si el segundo parametro es mayor que el primero
*/

int comparar(const void *a, const void *b) {
    int *n, *m;

    n = (int *)a;
    m = (int *)b;

    return (*n - *m);
}
