#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Desarrollar un programa que lea e imprima una serie de arreglos bidimensionales 
(matrices) de numeros enteros.

La estrada del programa se dar por entrada estndar, y consistirn en un conjunto de lneas
con el siguiente formato:

n m
numero1_1 numero1_2 ....  numero1_m
numero2_1 numero2_2 ....  numero2_m
...
numeroN_1 numeroN_2 ....  numeroN_M

El programa deber terminar al encontrar la palabra "end"

*/


#define MAX_N 40 // Maximo numero (arbitrario) de filas de la matriz 
#define MAX_M 40 // Maximo numero de columnas de la matriz


int main(int argc, char * argv[]) {
    char linea[80]; //Variable para leer una lnea de entrada
    FILE *fd;      //Descriptor de archivo de entrada

    int n, m;      // Variables para almacenar el tamao de la matriz
    int numero; //Variable para almacenar un numero leido

    int numeros[MAX_N][MAX_M];

    int posicion; //Variable que almacena el desplazamiento desde el inicio de la linea
    int count; //Variable que almacena el numero de caracteres leidos

    int i, j;

    if (argc > 1) { //Se especific un parmetro por lnea de comandos?
       fd = fopen(argv[1], "r");    //Intentar abrir el archivo
       if (!fd) { //No se puede abrir el archivo?
          fd = stdin; //Usar la entrada estndar (stdin = entrada estndar)
       }
    }else { //No se especific un parmetro por lnea de comandos
          fd = stdin;
    }
    
    // Leer lneas de la entrada hasta encontrar la palabra "end"

    while (!feof(fd))  { //ciclo principal
          fgets(linea, 80, fd);  //Leer una linea de hasta 80 caracteres

          //Validar si la lnea est vaca
          if (strlen(linea) <= 1) {continue;} //continue : ir al inicio del ciclo

          //Validar si la lnea es un comentario
          if (linea[0] == '#') {continue;}

          //Validar por fin de la entrada
          if (strcmp(linea, "end") == 0 || strcmp(linea, "end\n") == 0) {
             break; //Terminar el ciclo
          }

          n = 0;
          m = 0;
          //Si se leen dos parametros (m y n), continuar el proceso
         if (sscanf(linea, "%d%d", &n, &m) == 2 && n > 0 && m > 0) {          

             numero = 0;
             //Se conoce de antemano n y m, se puede utilizar un ciclo for
             for (i=0; i<n; i++) {
                 fgets(linea, 80, fd);  //Leer una linea de numeros
                 posicion = 0; //Iniciar el desplazamiento en la linea
                 for (j=0; j<m; j++) {
                     if (sscanf(linea + posicion, "%d%n", &numero, &count) == 1) {
                        numeros[i][j] = numero;
                        posicion = posicion + count;
                     }
                 }
             }

             //Ahora imprimr la matriz
             printf ( "Matriz de %d x %d\n", n, m);
             for (i=0; i<n; i++) {
                 for (j=0; j<m; j++) {
                     printf("%d ", numeros[i][j]);
                 }
                 printf("\n");
             }
             printf("\n");

         }
          
    }

    system("pause");
}
