#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h> //Necesaria para la funcion minus

/* Desarrollar un programa que reciba comandos para realizar calculos aritmeticos.
Los comandos validos son:

sumar n m
restar n m
multiplicar n m 
dividir n m

En donde n y m son numeros enteros. Para cada comando el programa deber imprimir
la operacin aritmtica y calcular su resultado.

El programa deber terminar al encontrar la palabra "end"

*/

//Funcion auxiliar para pasar una cadena de mayusculas a minusculas
void minus(char *);


int comparar(const void *, const void *);


int main(int argc, char * argv[]) {
    char linea[80]; //Variable para leer una lnea de entrada
    FILE *fd;      //Descriptor de archivo de entrada

    char comando[15];
    int n;
    int m;

    if (argc > 1) { //Se especific un parmetro por lnea de comandos?
       fd = fopen(argv[1], "r");    //Intentar abrir el archivo
       if (!fd) { //No se puede abrir el archivo?
          fd = stdin; //Usar la entrada estndar (stdin = entrada estndar)
       }
    }else { //No se especific un parmetro por lnea de comandos
          fd = stdin;
    }
    
    // Leer lneas de la entrada hasta encontrar la palabra "end"

    while (!feof(fd))  { //ciclo principal
          fgets(linea, 80, fd);  //Leer una linea de hasta 80 caracteres

          //Validar si la lnea est vaca
          if (strlen(linea) <= 1) {continue;} //continue : ir al inicio del ciclo

          //Validar si la lnea es un comentario
          if (linea[0] == '#') {continue;}

          minus(linea); //Convertir la linea a minusculas

          //Validar por fin de la entrada
          if (strcmp(linea, "end") == 0 || strcmp(linea, "end\n") == 0) {
             break; //Terminar el ciclo
          }

          n = 0;
          m = 0;
          //Si se leen dos parametros (m y n), continuar el proceso
         if (sscanf(linea, "%s%d%d", comando, &n, &m) == 3) { 
            if (strcmp(comando, "sumar")== 0) {
               printf("%d + %d = %d\n", n, m, n+m);
            }else if (strcmp(comando, "restar")== 0) {
               printf("%d - %d = %d\n", n, m, n-m);
            }else if (strcmp(comando, "multiplicar")== 0) {
               printf("%d x %d = %d\n", n, m, n*m);
            }else if (strcmp(comando, "sumar")== 0) {
               printf("%d / %d = %d\n", n, m, n/m);
            }
         } 
          
    }

    system("pause");
}


/* Funcion auxiliar para convertir una cadena de mayusculas a minusculas 
   Esta funcion modifica la cadena original.
*/


void minus(char *s) {
     char *aux;

     aux = s;
     while (*aux != '\0') { //Mientras no sea el fin de cadena
           if (isalpha(*aux) && isupper(*aux)) { //Si el caracter esta en mayusculas
              *aux = tolower(*aux); //Pasarlo a minusculas
           }
           aux++; //avanzar en la cadena
     }
}
